module DTK
  module DTK::CrdParser
      require_relative('crd_parser/base_class')
    
      require_relative('crd_parser/component')
      require_relative('crd_parser/component_def')
      require_relative('crd_parser/action')
      require_relative('crd_parser/error')

      def self.parse_crd_to_component(client, component_instance, component_name) 
        #component instance has a name and a namespace {name: xxx, namespace: yyy}
        #client is kube client
        #component name is, for example, network-aws::vpc[vpc1]
        Component.create_from_kube(client, component_instance, component_name)
      end

      def self.parse_crd_to_actions(client, component_instance, component_name)
        Action.ndxExecutableActions(client, component_instance, component_name)
      end

      private
    end
  end