module DTK::CrdParser
  class ExecutableAction < BaseClass

    attr_reader :entrypoint, :bash_script, :name, :type

    def initialize(params)
      @name = params[:name]
      @entrypoint = params[:entrypoint]
      @type = params[:type]
      @bash_script = params[:bash_script]
    end
    
    private

    def self.create_from_kube(client, component_instance, component_name)
      component_obj = Component.create_from_kube(client, component_instance, component_name)
      actions = component_obj.component_def.executable_actions
      executable_actions = Hash.new
      if actions
        actions.to_hash.each do |name, action|
          params = {
            name: name.to_s,
            entrypoint: action[:entrypoint] || "",
            type: action[:type] || "",
            bash_script: action[:bash_script] || ""
          }
          executable_actions[name.to_sym] = ExecutableAction.new(params)
        end
      end
      executable_actions
    end

  end
end